/*
{*NAME*}
	__FILE__ -- strstrn comparison routines

{*SYNOPSIS*}
	__FILE__

{*CLASS*}
	files:generic

{*DESCRIPTION*}
	String match functions for strings of known length with internal zeroes.

{*ENVIRONMENT*}

{*SYSTEM REQUIREMENTS*}

{*ALGORITHM*}

{*COMPILATION INSTRUCTIONS*}

{*RESOURCE CONTROL*}
	$Id: strstrn.c,v 1.2 1996/03/03 22:57:02 roy Beta2 $
	$Log: strstrn.c,v $
	Revision 1.2  1996/03/03 22:57:02  roy
	func:cont
	id'ing xuxa beta2 to match avid's beta3 tests

 * Revision 1.1  1995/11/02  19:33:00  quandt
 * Initial revision
 *
 * Revision 1.3  1994/05/14  00:55:51  quandt
 * func:cont
 *
 * Revision 1.2  1994/02/24  21:45:46  quandt
 * doc.change
 * Added the #include<strstrn.p> so that we don't get proto's mixed up
 *
 * Revision 1.1  1993/12/06  21:58:05  quandt
 * Initial revision
 *

{*SEE ALSO*}

{*BUGS*}

{*CREDITS*}

{*COPYRIGHT*}
	Copyright 1993 Heuris Logic.
	All rights reserved.
{**}
*/

#include <stddef.h>
#include <strstrn.p>


/*
{*NAME*}
	strstrn -- find a string match (including possible zero chars)

{*SYNOPSIS*}
	char *strstrn(char *ptr1, \* source string *\
		int len1,	\* length of source string *\
		char *ptr2, \* string to match *\
		int len2) \* length of string to match *\

{*CLASS*}
	c:i/o

{*DESCRIPTION*}
	Finds a match in source string for match string, if it exists.  Searches
	up to last position in source that could match second string, allowing
	zero character values within given lengths of each string.

{*ENVIRONMENT*}

{*ALGORITHM*}

{*SEE ALSO*}

{*BUGS*}

{*CREDITS*}

{*COPYRIGHT*}
	Copyright 1993 Heuris Logic.
	All rights reserved.
{**}
*/
char *strstrn(char *ptr1,
	int len1,
	char *ptr2,
	int len2)
{
	int len,start;
	char *ret=NULL;

	/* avoid any work if second string can't possibly be in first */
	if (len2 <= len1)
	{
		for(start=0,len=0; (start <= (len1-len2))&&(len!=len2); start++)
		{
			ret = &ptr1[start];
			for (len = 0; (len<len2)&&(ret[len]==ptr2[len]); len++);
		}
		if (len!=len2)
			ret = NULL;
	}
	return(ret);
}

