void	Construct_Mono_Pred(
	BYTE	*predictY,
	BYTE	*predictU,
	BYTE	*predictV,
	BYTE	*constY,
	BYTE	*constU,
	BYTE	*constV,
	short	MV[]
	);

void	Construct_Bi_Pred(
	BYTE	*predictY,
	BYTE	*predictU,
	BYTE	*predictV,
	BYTE	*predictYB,
	BYTE	*predictUB,
	BYTE	*predictVB,
	BYTE	*constY,
	BYTE	*constU,
	BYTE	*constV,
	short	MV[],
	short	MVB[]
	);

int	Get_Bits(
	unsigned int	*destBuf,
	int				numBits);

int	Next_Bits(
	unsigned int	*destBuf,
	int				numBits);

int Next_Start_Code(void);

int Get(
	int numBits);

int	Get_AC_Code(
	BYTE			*bitCount,
	BYTE			*bitPattern,
	int                      tblLen,
	int                     *signBit,
	int				*run,
	int				*level,
	int				first);

int	Get_Code(
	BYTE			*bitCount,
	BYTE			*bitPattern,
	int				tblLen);

int	Find_Code(
	BYTE			*bitCount,
	BYTE			*bitPattern,
	int				tblLen,
	unsigned int	buf,
	int				numBits);

int	Get_Coefs(
	int		*currentMBDiff,
	int		currentIndex,
	int		offset);

void	Perform_IDCT(
	int		mbType,
	int		*currentMBDiff,
	int		*currentMBDiffU,
	int		*currentMBDiffV);

int	Write_Picture(
	int			aPictureNum,
	BYTE		*y,
	BYTE		*u,
	BYTE		*v,
	tParameter	*aParameter);

int	Write_SIF(
	int			aPictureNum,
	BYTE		*luminPictureR,
	BYTE		*chromUPictureR,
	BYTE		*chromVPictureR,
	tParameter	*aParameter);

int	Write_TGA(
	int			aPictureNum,
	BYTE		*y,
	BYTE		*u,
	BYTE		*v,
	tParameter	*aParameter);

int	Write_PPM(
	int			aPictureNum,
	BYTE		*y,
	BYTE		*u,
	BYTE		*v,
	tParameter	*aParameter);

void	yuvtorgb(
	int		y,
	int		u,
	int		v,
	int		*pr,
	int		*pg,
	int		*pb);

void	convert420to422(
	BYTE	*chromPicture,
	int		chromWidth,
	int		chromHeight);

void	filter(
	int	n,
	int	*F,
	int	*G);

void convert420to444(
	BYTE	*chrom420,
	BYTE	*chrom444,
	int		chromWidth,
	int		chromHeight);

void Init_DCT(void);

void idct8x8(
	float	dct_img[],
	float	recon_img[]);

void	Initial(
	tParameter		*aParameter,
	char			*parameterFName);

void Init_Data(
	tData			*aData);

BYTE	*Barray(
	int	size);

short *Sarray(
	int	size);

void	Inverse_Quantize_Intra_MB(
	short	codedBPattern,
	int		*currentMBDiff,
	int		*currentMBDiffU,
	int		*currentMBDiffV,
	int		MQuant);

void	Inverse_Quantize_Non_Intra_MB(
	short	codedBPattern,
	int		*currentMBDiff,
	int		*currentMBDiffU,
	int		*currentMBDiffV,
	int		MQuant);

int	Process_MB(
	int		*currentMBDiff,
	int		*currentMBDiffU,
	int		*currentMBDiffV,
	int		*DCPredictionY,
	int		*DCPredictionU,
	int		*DCPredictionV,
	int		mbType,
	int		codedBPattern);

int Process_Block(
	int		i,
	int		patternCode,
	int		mbIntra,
	int		*DCPrediction,
	int		*dctRecon);

int	Process_Picture(
	int			pictureNum,
	tParameter	*parameter,
	tData		*data);

int	Process_Sequence(
	tParameter	*parameter,
	tData		*data);

void	Process_Sequence_Header(void);

void	Extension_And_User_Data();

int	Process_Slice(
	short		pictureType,
	BYTE		*bufY,
	BYTE		*bufU,
	BYTE		*bufV,
	tData		*data,
	int			forward_f_code,
	int			fullPelForwardV,
	int			backward_f_code,
	int			fullPelBackwardV);

int Get_MBA_Inc(void);

int	Get_MV(
	int		f_code,
	int		fullPelV,
	short	MV[2],
	short	PMV[]);

void	Copy_From_Buf(
	int			mbType,
	short		codedBPattern,
	int			mbRow,
	int			mbCol,
	BYTE		*bufYR,
	BYTE		*bufUR,
	BYTE		*bufVR,
	int			currentMBDiff[],
	int			currentMBDiffU[],
	int			currentMBDiffV[]);

