/* File:  initial.c  */

/*
 *      $Log:   initial.c,v $
 * Revision 1.5  93/12/07  12:00:00  sE
 *
 * Revision 1.4  93/09/03  01:15:00  hana
 * VBV buffer operation 
 * 
 * Revision 1.1.1.1  93/03/29  11:27:55  oosa
 * MPEG1 encoder/decoder initial revision
 * 
 * Revision 1.1  1993/03/10  20:33:17  au
 * Initial revision
 *
 */

#include <stdio.h>
#include <malloc.h>
#include "consts.h"
#include "types.h"
#include "decode.h"
#include "decode.pro"

void    Initial(
	tParameter              *aParameter,
	char                    *parameterFName)
{
	extern FILE     *gBitStream;

	FILE    *fptr;
	char    lineBuf[kMaxCharBufLen];

	/* get user input data */

	if ((fptr = fopen (parameterFName, "r")) == 0)
	{
		printf ("input parameter file '%s' not found\n", parameterFName);
		exit(-1);
	}

	fgets (lineBuf, kMaxCharBufLen, fptr);
	sscanf (lineBuf, "%s", aParameter->bitStreamFName);
	fgets (lineBuf, kMaxCharBufLen, fptr);
	sscanf (lineBuf, "%s", aParameter->outputSequence);
	fgets (lineBuf, kMaxCharBufLen, fptr);
	sscanf (lineBuf, "%d", &(aParameter->outputFormat));
	fgets (lineBuf, kMaxCharBufLen, fptr);
	sscanf (lineBuf, "%s", aParameter->statusFName);
	fgets (lineBuf, kMaxCharBufLen, fptr);
	sscanf (lineBuf, "%d", &TraceLevel);

	fclose (fptr);

	if ((gBitStream = fopen (aParameter->bitStreamFName, "rb")) == NULL)
	{
		printf ("error opening bitstream file '%s' ... Terminating ...\n",
				aParameter->bitStreamFName);
		exit(-1);
	}

	if (TraceLevel > 0)
	{
		if (aParameter->statusFName[0] == '-')
		  TraceFile = stdout;
		else if ((TraceFile = fopen (aParameter->statusFName, "w")) == NULL)
		{
			printf ("error creating trace file '%s' ... Terminating ...\n",
					aParameter->statusFName);
			exit(-1);
		}
	}
	

	Init_DCT();
}



void Init_Data(
	tData                   *aData)
{
	int numLuminPixels, numChromPixels;

	numLuminPixels = (16 * mb_width) * (16 * mb_height);
	numChromPixels = (8 * mb_width) * (16 * mb_height);

	/* Reconstructed picture array memory allocation */

	aData->luminPicture0R = Barray(numLuminPixels);
	aData->luminPicture1R = Barray(numLuminPixels);
	aData->luminPicture2R = Barray(numLuminPixels);

	aData->chromUPicture0R = Barray(numChromPixels);
	aData->chromUPicture1R = Barray(numChromPixels);
	aData->chromUPicture2R = Barray(numChromPixels);

	aData->chromVPicture0R = Barray(numChromPixels);
	aData->chromVPicture1R = Barray(numChromPixels);
	aData->chromVPicture2R = Barray(numChromPixels);

	/*      assign working pointers */

	aData->firstPredictYR = aData->luminPicture0R;
	aData->firstPredictUR = aData->chromUPicture0R;
	aData->firstPredictVR = aData->chromVPicture0R;
	aData->secondPredictYR = aData->luminPicture1R;
	aData->secondPredictUR = aData->chromUPicture1R;
	aData->secondPredictVR = aData->chromVPicture1R;
	aData->predictYR = aData->luminPicture2R;
	aData->predictUR = aData->chromUPicture2R;
	aData->predictVR = aData->chromVPicture2R;
}

BYTE    *Barray(
	int     size)
{
	BYTE    *a;

	a = (BYTE *) malloc((unsigned) size * sizeof(BYTE));

	if (!a)
	{
		printf("\nBarray: Failure in allocating arrary memory\n");
		exit(-1);
	}

	return a;
}

short *Sarray(
	int     size)
{
	short   *a;

	a = (short *) malloc((unsigned) size * sizeof(short));

	if (!a)
	{
		printf("\nSarray: Failure in allocating arrary memory\n");
		exit(-1);
	}

	return a;
}
