/* transfer.c  */

/*
 *      $Log:   transfer.c,v $
 * Revision 1.5  93/12/07  12:00:00  sE
 *
 * Revision 1.1.1.1  93/03/29  11:27:56  oosa
 * MPEG1 encoder/decoder initial revision
 * 
 * Revision 1.1  1993/03/10  20:33:17  au
 * Initial revision
 *
 */

#include <stdio.h>
#include "consts.h"
#include "types.h"
#include "decode.h"
#include "decode.pro"

void    Copy_From_Buf(
	int     macroblock_type,
	short   coded_block_pattern,
	int     MB_row,
	int     MB_col,
	BYTE    *buf_Y_recon,
	BYTE    *buf_Cb_recon,
	BYTE    *buf_Cr_recon,
	int     currentMBDiff[],
	int     currentMBDiffU[],
	int     currentMBDiffV[])
{
	int     bufIndex, bufIndex1, currentIndex, temp;
	short   code, line, pix, row, col;

	if (macroblock_type & kMbIntra)  /*      intra   */
	{
		bufIndex = MB_row * kMBHeight * (16 * mb_width) + MB_col * kMBWidth;

		/*      lumin   */

		for (row = 0, currentIndex = 0; row < kMBHeight; row++,
				bufIndex += 16 * mb_width - kMBWidth)
		{
			for (col = 0; col < kMBWidth; col++, currentIndex++, bufIndex++)
			{
				buf_Y_recon[bufIndex] = (currentMBDiff[currentIndex] >= 255) ? 255 :
						((currentMBDiff[currentIndex] <= 0) ? 0 :
						currentMBDiff[currentIndex]);
			}
		}

		/*      chrom   */

		bufIndex = MB_row * kBHeight * (8 * mb_width) + MB_col * kBWidth;

		for (row = 0, currentIndex = 0; row < kBHeight; row++,
				bufIndex += 8 * mb_width - kBWidth)
		{
			for (col = 0; col < kBWidth; col++, currentIndex++, bufIndex++)
			{
				buf_Cb_recon[bufIndex] = (currentMBDiffU[currentIndex] >= 255) ? 255 :
						((currentMBDiffU[currentIndex] <= 0) ? 0 :
						currentMBDiffU[currentIndex]);
				buf_Cr_recon[bufIndex] = (currentMBDiffV[currentIndex] >= 255) ? 255 :
						((currentMBDiffV[currentIndex] <= 0) ? 0 :
						currentMBDiffV[currentIndex]);
			}
		}
	}
	else    /*      inter   */
	{
		/*      lumin   */

		code = 0x20;

		for (line = 0; line < kMBHeight; line += kBHeight)
		{
			bufIndex1 = (MB_row * kMBHeight + line) * (16 * mb_width) +
					MB_col * kMBWidth;

			for (pix = 0; pix < kMBWidth; pix += kBWidth)
			{
				if (! (coded_block_pattern & code))
				{
					code >>= 1;
					continue;
				}

				bufIndex = bufIndex1 + pix;

				code >>= 1;

				currentIndex = line * kMBWidth + pix;

				for (row = 0; row < kBHeight;
						row++, currentIndex += kMBWidth - kBWidth,
						bufIndex += 16 * mb_width - kBWidth)
				{
					for (col = 0; col < kBWidth; col++, currentIndex++,
							bufIndex++)
					{
						temp = buf_Y_recon[bufIndex] + currentMBDiff[currentIndex];
						buf_Y_recon[bufIndex] =
								(temp >= 255) ? 255 : ((temp <= 0) ? 0 : temp);
					}
				}
			}
		}

		/*      chrom - U       */

		if (coded_block_pattern & 0x02)
		{
			bufIndex = MB_row * kBHeight * (8 * mb_width) + MB_col * kBWidth;

			for (row = 0, currentIndex = 0; row < kBHeight; row++,
					bufIndex += 8 * mb_width - kBWidth)
			{
				for (col = 0; col < kBWidth; col++, currentIndex++, bufIndex++)
				{
					temp = buf_Cb_recon[bufIndex] + currentMBDiffU[currentIndex];
					buf_Cb_recon[bufIndex] =
							(temp >= 255) ? 255 : ((temp <= 0) ? 0 : temp);
				}
			}
		}

		/*      chrom - V       */

		if (coded_block_pattern & 0x01)
		{
			bufIndex = MB_row * kBHeight * (8 * mb_width) + MB_col * kBWidth;

			for (row = 0, currentIndex = 0; row < kBHeight; row++,
					bufIndex += 8 * mb_width - kBWidth)
			{
				for (col = 0; col < kBWidth; col++, currentIndex++, bufIndex++)
				{
					temp = buf_Cr_recon[bufIndex] + currentMBDiffV[currentIndex];
					buf_Cr_recon[bufIndex] =
							(temp >= 255) ? 255 : ((temp <= 0) ? 0 : temp);
				}
			}
		}
	}
}
