/*************************************************************************
 **																		**
 **	File:	types.h														**
 **	Code by:	Peter H. Au, Hughes Aircraft Company					**
 **				for the MPEG1 Technical Report							**
 **																		**
 **																		**
 **	Copyright (c) 1992 by ISO-IEC JTC1/SC29/WG11						**
 **	All rights reserved.												**
 **																		**
 **	Permission is granted to copy, use, or modify this program, for		**
 **	the development of the MPEG1 Technical Report.  It may not be sold	**
 **	for profit, the copyright notice must be reproduced on copies, and	**
 **	credit should be given as apropriate where it is due.				**
 **																		**
 **	HUGHES AIRCRAFT COMPANY MAKES NO WARRANTY AND ACCEPTS NO LIABILITY	**
 **	FOR THIS PROGRAM.													**
 **																		**
 *************************************************************************/

/*
 *	$Log:	types.h,v $
 * Revision 1.5  93/12/07  12:00:00  sE
 *
 * Revision 1.4  93/09/03  1:15:00  hana
 * VBV buffer operation 
 * 
 * Revision 1.1.1.1  93/03/29  11:27:53  oosa
 * MPEG1 encoder/decoder initial revision
 * 
 * Revision 1.1  1993/03/10  20:32:40  au
 * Initial revision
 *
 */

typedef struct t_Data		/*	picture data	*/
{
	/*	working pointers	*/

	BYTE *firstPredictYR;	/*	reconstructed 1st prediction picture	*/
	BYTE *firstPredictUR;	/*	reconstructed 1st prediction picture	*/
	BYTE *firstPredictVR;	/*	reconstructed 1st prediction picture	*/
	BYTE *secondPredictYR;	/*	reconstructed 2nd prediction picture	*/
	BYTE *secondPredictUR;	/*	reconstructed 2nd prediction picture	*/
	BYTE *secondPredictVR;	/*	reconstructed 2nd prediction picture	*/
	BYTE *predictYR;		/*	reconstructed B picture	*/
	BYTE *predictUR;		/*	reconstructed B picture	*/
	BYTE *predictVR;		/*	reconstructed B picture	*/

	/*	storage arrays	*/

	BYTE *luminPicture0R;	/*	reconstructed luminance of picture 0	*/
	BYTE *luminPicture1R;	/*	reconstructed luminance of picture 1	*/
	BYTE *luminPicture2R;	/*	reconstructed luminance of picture 2	*/
	BYTE *chromUPicture0R;	/*	reconstructed chrominance of picture 0	*/
	BYTE *chromUPicture1R;	/*	reconstructed chrominance of picture 1	*/
	BYTE *chromUPicture2R;	/*	reconstructed chrominance of picture 2	*/
	BYTE *chromVPicture0R;
	BYTE *chromVPicture1R;
	BYTE *chromVPicture2R;
} tData;

typedef struct t_Parameter		/*	user parameter	*/
{
	char	inputSequence[kMaxCharBufLen],
			outputSequence[kMaxCharBufLen],
			statusFName[kMaxCharBufLen],
			ACVlc_FName[kMaxCharBufLen],
			bitStreamFName[kMaxCharBufLen];
	int		outputFormat;
} tParameter;

