/*
  File:   ACVlc.c                                                                                                         **
*/
 
 /*      $Log:   ACVLC.c,v $
 * Revision 1.2  93/06/15  15:36:44  oosa
 * 
 * 
 * Revision 1.1  1993/03/10  20:30:43  au
 * Initial revision
 *
 */

#include "consts.h"
#include "mpeg1.h"
#include "bitcount.h"
#include "encoder.pro"

/* initialize dct_coeff_next tables for encoder */
void    Init_AC_VLC(void)
{
	extern BYTE     AC_length[][256];   /* code length */
	extern BYTE     AC_value[][256];    /* code value */
	int             run, level;

	/* Code length for FLC escape events */

	for (run = 0; run < 64; run++)          /* single escape */
		for (level = 0; level < 128; level++)
			AC_length[run][level] = 20;         
	for (run = 0; run < 64; run++)          /* double escape */
		for (level = 128; level < 256; level++)
			AC_length[run][level] = 28;

	
	/* Code lengths for VLC events */
	
	AC_length[0][0] = 2;        /* EOB code */
	AC_length[0][1] = 3;
	AC_length[1][1] = 4;
	AC_length[2][1] = AC_length[0][2] = 5;
	AC_length[3][1] = AC_length[4][1] = AC_length[0][3] = 6;
	AC_length[5][1] = AC_length[1][2] = AC_length[6][1] = AC_length[7][1] = 7;
	AC_length[8][1] = AC_length[0][4] = AC_length[9][1] = AC_length[2][2] = 8;

	AC_length[10][1] = AC_length[0][5] = AC_length[1][3] = AC_length[3][2] =  AC_length[11][1]
		= AC_length[12][1] = AC_length[0][6] = AC_length[13][1] = 9;

	AC_length[4][2] = AC_length[14][1] = AC_length[15][1] = AC_length[1][4] =  AC_length[2][3]
		= AC_length[0][7] = AC_length[5][2] = AC_length[16][1] = 11;

	AC_length[17][1] = AC_length[6][2] = AC_length[0][8] = AC_length[3][3] =  AC_length[1][5]
		= AC_length[18][1] = AC_length[19][1] = AC_length[0][9] =  AC_length[20][1]
			= AC_length[21][1] = AC_length[7][2] = AC_length[2][4] =  AC_length[0][10]
			= AC_length[4][3] = AC_length[8][2] = AC_length[0][11] = 13;

	AC_length[22][1] = AC_length[23][1] = AC_length[24][1] = AC_length[25][1] =  AC_length[26][1]
		= AC_length[9][2] = AC_length[10][2] = AC_length[5][3] =  AC_length[3][4]
			= AC_length[2][5] = AC_length[1][6] = AC_length[1][7] =  AC_length[0][12]
			= AC_length[0][13] = AC_length[0][14] = AC_length[0][15] = 14;

	AC_length[0][16] = AC_length[0][17] = AC_length[0][18] = AC_length[0][19] =  AC_length[0][20]
		= AC_length[0][21] = AC_length[0][22] = AC_length[0][23] = AC_length[0][24]
		= AC_length[0][25] = AC_length[0][26] = AC_length[0][27] = AC_length[0][28]
		= AC_length[0][29] = AC_length[0][30] = AC_length[0][31] = 15;

	AC_length[0][32] = AC_length[0][33] = AC_length[0][34] = AC_length[0][35] =  AC_length[0][36]
		= AC_length[0][37] = AC_length[0][38] = AC_length[0][39] = AC_length[0][40]
		= AC_length[1][8] = AC_length[1][9] = AC_length[1][10] = AC_length[1][11]
		= AC_length[1][12] = AC_length[1][13] = AC_length[1][14] = 16;
	
	AC_length[1][15] = AC_length[1][16] = AC_length[1][17] = AC_length[1][18] =  AC_length[6][3]
		= AC_length[11][2] = AC_length[12][2] = AC_length[13][2] = AC_length[14][2]
		= AC_length[15][2] = AC_length[16][2] = AC_length[27][1] = AC_length[28][1]
		= AC_length[29][1] = AC_length[30][1] = AC_length[31][1] = 17;

	/* code word values for FLC escape events */
	for (level = 1; level < 256; level++)
	{
		AC_value[EscapeOffset][level] = level;    /* positive */
		AC_value[EscapeOffset + 1][level] =       /* negative */
			~AC_value[EscapeOffset][level] + 1;
	}

	/* code word values for VLC events */
	AC_value[0][0] = 2;        /* EOB code */
	AC_value[0][1] = 6;
	AC_value[1][1] = 6;
	AC_value[2][1] = 10;
	AC_value[0][2] = 8;
	AC_value[3][1] = 14;
	AC_value[4][1] = 12;
	AC_value[0][3] = 10;
	AC_value[5][1] = 14;
	AC_value[1][2] = 12;
	AC_value[6][1] = 10;
	AC_value[7][1] = 8;
	AC_value[8][1] = 14;
	AC_value[0][4] = 12;
	AC_value[9][1] = 10;
	AC_value[2][2] = 8;
	AC_value[10][1] = 78;
	AC_value[0][5] = 76;
	AC_value[1][3] = 74;
	AC_value[3][2] = 72;
	AC_value[11][1] = 70;
	AC_value[12][1] = 68;
	AC_value[0][6] = 66;
	AC_value[13][1] =64;
	AC_value[4][2] = 30;
	AC_value[14][1] = 28;
	AC_value[15][1] = 26;
	AC_value[1][4] = 24;
	AC_value[2][3] = 22;
	AC_value[0][7] = 20;
	AC_value[5][2] = 18;
	AC_value[16][1] = 16;
	AC_value[17][1] = 62;
	AC_value[6][2] = 60;
	AC_value[0][8] = 58;
	AC_value[3][3] = 56;
	AC_value[1][5] = 54;
	AC_value[18][1] = 52;
	AC_value[19][1] = 50;
	AC_value[0][9] = 48;
	AC_value[20][1] = 46;
	AC_value[21][1] = 44;
	AC_value[7][2] = 42;
	AC_value[2][4] = 40;
	AC_value[0][10] = 38;
	AC_value[4][3] = 36;
	AC_value[8][2] = 34;
	AC_value[0][11] = 32;
	AC_value[22][1] = 62;
	AC_value[23][1] = 60;
	AC_value[24][1] = 58;
	AC_value[25][1] = 56;
	AC_value[26][1] = 54;
	AC_value[9][2] = 34;
	AC_value[10][2] = 32;
	AC_value[5][3] = 36;
	AC_value[3][4] = 38;
	AC_value[2][5] = 40;
	AC_value[1][6] = 44;
	AC_value[1][7] = 42;
	AC_value[0][12] = 52;
	AC_value[0][13] = 50;
	AC_value[0][14] = 48;
	AC_value[0][15] = 46;
	AC_value[0][16] = 62;
	AC_value[0][17] = 60;
	AC_value[0][18] = 58;
	AC_value[0][19] = 56;
	AC_value[0][20] = 54;
	AC_value[0][21] = 52;
	AC_value[0][22] = 50;
	AC_value[0][23] = 48;
	AC_value[0][24] = 46;
	AC_value[0][25] = 44;
	AC_value[0][26] = 42;
	AC_value[0][27] = 40;
	AC_value[0][28] = 38;
	AC_value[0][29] = 36;
	AC_value[0][30] = 34;
	AC_value[0][31] = 32;
	AC_value[0][32] = 48;
	AC_value[0][33] = 46;
	AC_value[0][34] = 44;
	AC_value[0][35] = 42;
	AC_value[0][36] = 40;
	AC_value[0][37] = 38;
	AC_value[0][38] = 36;
	AC_value[0][39] = 34;
	AC_value[0][40] = 32;
	AC_value[1][8] = 62;
	AC_value[1][9] = 60;
	AC_value[1][10] = 58;
	AC_value[1][11] = 56;
	AC_value[1][12] = 54;
	AC_value[1][13] = 52;
	AC_value[1][14] = 50;
	AC_value[1][15] = 38;
	AC_value[1][16] = 36;
	AC_value[1][17] = 34;
	AC_value[1][18] = 32;
	AC_value[6][3] = 40;
	AC_value[11][2] = 52;
	AC_value[12][2] = 50;
	AC_value[13][2] = 48;
	AC_value[14][2] = 46;
	AC_value[15][2] = 44;
	AC_value[16][2] = 42;
	AC_value[27][1] = 62;
	AC_value[28][1] = 60;
	AC_value[29][1] = 58;
	AC_value[30][1] = 56;
	AC_value[31][1] = 54;
}
