/*  File:   consts.h */  

/*
 *      $Log:   consts.h,v $
 * Revision 1.4  93/09/03  01:15:00  hana
 * VBV buffer operation 
 * 
 * Revision 1.1.1.1  93/03/29  11:27:53  oosa
 * MPEG1 encoder/decoder initial revision
 * 
 * Revision 1.1  1993/03/10  20:32:40  au
 * Initial revision
 *
 */

#define kMaxCharBufLen  80   

#define FALSE 0
#define TRUE  1

#define BYTE                    unsigned char
#define RND(i,x)                i = ((x)>0.0 ? floor((x)+0.5) : ceil((x)-0.5))
#define TRUNC(i,x)              i = ((x)>0.0 ? floor((x)) : ceil((x))

#define kMBWidth                16      /*  width of Macro Block in pel  */
#define kMBHeight               16      /*  height of Macro Block in pel */

/* picture dimension routines need to be moved into initial.c */

#define FORWARD         0       /*  for 4:2:2 to 4:2:0 conversion */
#define INVERSE         1       /*  for 4:2:0 to 4:2:2 conversion */
#define FIELD_1         1       /*  sometimes called field 0 */
#define FIELD_2         2       /*  sometimes called field 1 */

#define kIPicture       1       /*      I picture type          */
#define kPPicture       2       /*      P picture type          */
#define kBPicture       3       /*      B picture type  */
#define kBPicture1      3       /*      1st B picture type      */
#define kBPicture2      4       /*      2nd B picture type      */

#define kMBLen          (kMBWidth * kMBHeight)  /*  # of pels in MB  */
#define kDCTSize        8                       /*  width and height of DCT Block in pel */
#define kDCTLen         (kDCTSize * kDCTSize)   /*  # of pels in DCT Block  */
#define kBWidth         8                       /*  width of Chrom Block in pel */
#define kBHeight        8                       /*  height of Chrom Block in pel */
#define kBLen           (kBWidth * kBHeight)    /*  # of pels in block */

#define kMCType                 0x0002  /*  motion compensated  macro block type */
#define kIntraType              0x0004  /*  intra macro block type */
#define kCodedType              0x0010  /*  coded macro block type */
#define kForwardMV              0x0020  /*  forward mv  */
#define kBackwardMV             0x0040  /*  backward mv  */
#define kModifiedMQ             0x0080  /*  modified quantizer  */

#define kMBWidthDCT             (kMBWidth - kDCTSize)
