void    Init_AC_VLC(
	void);

void    Write_Sequence_Header(
	tParameter      *parameter,
	tRateControl    *rateControl);

short   Write_GOP_Header(
	tParameter      *parameter,
	tRateControl    *rateControl);

short   Write_Picture_Header(
	short           picture_coding_type,
	tRateControl    *rateControl,
	short           forward_f_code,
	short           backward_f_code,
	int             temporal_reference);

short   Write_Slice_Header(
	short           picture_coding_type,
	tRateControl    *rateControl);

int     Write_MB(
	short           picture_coding_type,
	int             macrblock_type,
	short           coded_block_pattern,
	tRateControl    *rateControl,
	tParameter      *parameter,
	int             MB_row,
	int             MB_col,
	short           forwardMV[],
	short           backwardMV[],
	int             y_coef[],
	int             cb_coef[],
	int             cr_coef[],
	int             quantizer_scale,
	short           fRange,
	short           forward_f_code,
	short           bRange,
	short           backward_f_code,
	int             *new_macroblock_type);

void    Write_MV(
	int             *diff_vector,
	short           numDiffVectors,
	short           f_code,
	short           range,
	int             *MB_bit_count,
	tParameter      *parameter,
	short           picture_coding_type);

void    Write_Intra_Coefficients(
	int             *y_coef,
	int             *cr_coef,
	int             *cb_coef,
	int             *dct_dc_past_y,
	int             *dct_dc_past_cb,
	int             *dct_dc_past_cr,
	int             *MB_bit_count);

void    Write_Non_Intra_Coefficients(
	int             *y_coef,
	int             *cb_coef,
	int             *cr_coef,
	int             *MB_bit_count,
	short           coded_block_pattern);

int     Write_AC_VLC(
	int             diff,
	short           *run,
	int             *MB_bit_count,
	short           first);

short   CheckMbType(
	int             prevMbType,
	int             mbType,
	short           codedBPattern);

int     CalSE(
	BYTE            *current,
	BYTE            *predictY,
	short           MV[],
	tParameter      *parameter);

int     Construct(
	BYTE            predictY[],
	BYTE            predictU[],
	BYTE            predictV[],
	BYTE            *constY,
	BYTE            *constU,
	BYTE            *constV,
	BYTE            current[],
	BYTE            currentU[],
	BYTE            currentV[],
	short           MV[],
	int             *diff,
	int             *diffU,
	int             *diffV,
	tParameter      *parameter);

int     IntraCheck(
	BYTE            current[],
	BYTE            currentU[],
	BYTE            currentV[],
	BYTE            *constY,
	BYTE            *constU,
	BYTE            *constV,
	int             *diff,
	int             *diffU,
	int             *diffV,
	tParameter      *parameter);

int     ConstructB(
	BYTE    predictY[],
	BYTE    predictU[],
	BYTE    predictV[],
	BYTE    predictY2[],
	BYTE    predictU2[],
	BYTE    predictV2[],
	BYTE    *constY,
	BYTE    *constU,
	BYTE    *constV,
	BYTE    current[],
	BYTE    currentU[],
	BYTE    currentV[],
	short   MV[],
	short   MVB[],
	int     *diff,
	int     *diffU,
	int     *diffV,
	tParameter      *parameter);

int     ConstructI(
	BYTE    *constY,
	BYTE    *constU,
	BYTE    *constV,
	BYTE    *current,
	BYTE    *currentU,
	BYTE    *currentV,
	int     *diff,
	int     *diffU,
	int     *diffV,
	tParameter      *parameter);

int     ICalSE(
	BYTE    *current,
	BYTE    *predictY,
	BYTE    *predictYB,
	short   MV[],
	short   MVB[],
	tParameter      *parameter);

void    PreFrame(
	short           pictureType,
	tParameter      *parameter,
	tRateControl    *rateControl,
	short           forward_f_code,
	short           backward_f_code);

void    PostFrame(
	short           pictureType,
	tRateControl    *rateControl,
	tParameter      *parameter);

void    DoPreMBRC(
	short           pictureType,
	tRateControl    *rateControl,
	BYTE            *currentMB,
	int             *MQuant);

void    PerformDct(
	int             mbType,
	BYTE            currentMB[],
	int             *currentMBDiff,
	int             *currentMBDiffU,
	int             *currentMBDiffV,
	int             mbIndex);

void    dct8x8(
	float   frame[],                        /* picture store */
	float   trframe[]);                     /* dct transformed picture */

void    writeBits(
	unsigned int    bits,
	short           numBits,
	short           startCode);

void    Write_Intra_Coefficients(
	int             *currentMBDiff,
	int             *currentMBDiffU,
	int             *currentMBDiffV,
	int             *DCPredictionY,
	int             *DCPredictionU,
	int             *DCPredictionV,
	int             *MB_bit_count);

/*
short   GetMotionVector(
	BYTE    *reconst,
	BYTE    *original,
	BYTE    *current,
	short   bufMV[][2],
	short   searchDistance,
	int     halfPel,       
	short   fileMV,
	char    *fName,
	tParameter      *parameter);
*/

unsigned int    HalfPel(
	BYTE                    *original,
	BYTE                    *current,
	int                     *hor,
	int                     *ver,
	int                     bufRow,
	int                     bufCol,
	unsigned int            minF,
	short                   offset,
	tParameter              *parameter);
 

short   GetMotionVector(
	BYTE    *reconst,
	BYTE    *original,
	BYTE    *current,
	short   bufMV[][2],
	int     searchDistance,
	int     halfPel,
	int     fileMV,
	char    *fName,
	tParameter *parameter);



/* 
unsigned int    HalfPel(
	BYTE            *original,
	BYTE            *current,
	short           mv[],
	int             bufRow,
	int             bufCol,
	unsigned int    minF,
	short           offset,
	short           mvF[],
        tParameter      *parameter);

*/


void    ProcessMB(
	tData           *data,
	tParameter      *parameter,
	tRateControl    *rateControl,
	BYTE            *bufY,
	BYTE            *bufU,
	BYTE            *bufV,
	BYTE            *bufYR,
	BYTE            *bufUR,
	BYTE            *bufVR,
	short           pictureType,
	int             pictureNum,
	short           forwardMV[][2],
	short           backwardMV[][2],
	int             mbType[],
	short           codedBPattern[],
	int             MQuant[]);

int     QuantizeI(
	short           *codedBPattern,
	int             *currentMBDiff,
	int             *currentMBDiffU,
	int             *currentMBDiffV,
	int             MQuant);

int     Quantize(
	short           *codedBPattern,
	int             *currentMBDiff,
	int             *currentMBDiffU,
	int             *currentMBDiffV,
	int             MQuant);

int     calcVbvDelay(
	short           pictureType,
	tRateControl    *rateControl,
	tParameter      *parameter);

void    checkUpdateVbv(
	short           pictureType,
	int             pictureNum,     
	tRateControl    *rateControl,
	tParameter      *parameter);

void    GetLoc(
	short   MV[],
	short   *f0off2,
	short   *f0off3,
	short   *f0off4,
	short   width);

void    FrameConstr(
	BYTE    *predictY,
	BYTE    *predictU,
	BYTE    *predictV,
	BYTE    *constY,
	BYTE    *constU,
	BYTE    *constV,
	short   MV[],
	BYTE    *current,
	BYTE    *currentU,
	BYTE    *currentV,
	int     *diff,
	int     *diffU,
	int     *diffV,
	tParameter      *parameter);

void    FrameIConstr(
	BYTE    *predictY,
	BYTE    *predictU,
	BYTE    *predictV,
	BYTE    *predictYB,
	BYTE    *predictUB,
	BYTE    *predictVB,
	BYTE    *constY,
	BYTE    *constU,
	BYTE    *constV,
	short   MV[],
	short   MVB[],
	BYTE    *current,
	BYTE    *currentU,
	BYTE    *currentV,
	int     *diff,
	int     *diffU,
	int     *diffV,
	tParameter      *parameter);


short   ReadPicture(
	int             aPictureNum,
	BYTE            *luminPicture,
	BYTE            *chromUPicture,
	BYTE            *chromVPicture,
	tParameter      *aParameter);


short   WritePicture(
	int             aPictureNum,
	short           aPictureType,
	BYTE            *luminPictureR,
	BYTE            *chromUPictureR,
	BYTE            *chromVPictureR,
	BYTE            *luminPicture,
	BYTE            *chromUPicture,
	BYTE            *chromVPicture,
	tParameter      *aParameter);


void    convert422to420(
	int             fieldNum,
	BYTE            *chromPicture,
	int             chromWidth,
	int             chromHeight,
	int             direction,
	tParameter      *parameter);


void    filter(
	int     fieldNum,
	int     nn,
	int     *FF,
	int     *GG,
	int     direction,
	tParameter  *parameter);


void    PerformIDct(
	int             mbType,
	int             *currentMBDiff,
	int             *currentMBDiffU,
	int             *currentMBDiffV);


void    idct8x8(
	float   trframe[],      /*      dct transformed picture */
	float   itrframe[]);    /*      picture store   */


void    Initial(
	tParameter              *aParameter,
	tData                   *aData,
	tRateControl            *aRateControl,
	char                    *parameterFName);


BYTE    *Barray(
	int     size);


short *Sarray(
	int     size);

int *Iarray(
	int     size);


void    IQuantizeI(
	short           codedBPattern,
	int             *currentMBDiff,
	int             *currentMBDiffU,
	int             *currentMBDiffV,
	int             MQuant);

void    IQuantize(
	short           codedBPattern,
	int             *currentMBDiff,
	int             *currentMBDiffU,
	int             *currentMBDiffV,
	int             MQuant);


void    printDiff(
	int     *currentMBDiff,
	int     *currentMBDiffU,
	int     *currentMBDiffV);


void    statistic(
	int             pictureNum,
	short           pictureType,
	tParameter      *parameter,
	BYTE            *original,
	BYTE            *originalU,
	BYTE            *originalV,
	BYTE            *reconst,
	BYTE            *reconstU,
	BYTE            *reconstV,
	int             numLuminPixels,
	int             numChromPixels);


void    snr(
	BYTE    *ycod,
	BYTE    *ysrc,
	double  *ysnr,
	BYTE    *ucod,
	BYTE    *usrc,
	double  *usnr,
	BYTE    *vcod,
	BYTE    *vsrc,
	double  *vsnr,
	int     numLuminPixels,
	int     numChromPixels);


void    CopyToBuf(
	int     bufIndex,
	int     bufIndexC,
	BYTE    bufY[],
	BYTE    bufU[],
	BYTE    bufV[],
	BYTE    *currentMB,
	BYTE    *currentMBU,
	BYTE    *currentMBV,
	int     *currentMBDiff,
	int     *currentMBDiffU,
	int     *currentMBDiffV,
	tParameter      *parameter);


void    CopyFromBuf(
	short           pictureType,
	int             mbType,
	short           codedBPattern,
	int             mbRow,
	int             mbCol,
	BYTE            *bufYR,
	BYTE            *bufUR,
	BYTE            *bufVR,
	int             currentMBDiff[],
	int             currentMBDiffU[],
	int             currentMBDiffV[],
	int             mbIndex,
	tParameter      *parameter);





int FullSearch(
	int                     *hor,
	int                     *ver,
	short                   searchDistance,                
	int                     halfPel,
	BYTE                    *reconst,
        BYTE                    *current_picture,
	BYTE                    *original,
	BYTE                    *current,
	int                     bufRow,
	int                     bufCol,
	tParameter              *parameter);

int MAE (BYTE           *currentIndex1, 
	 BYTE           *predictIndex,
	 tParameter     *parameter);                                

void    ProcSequence(
	tParameter      *parameter,
	tData           *data,
	tRateControl    *rateControl);

void    ProcPicture(
	tData           *data,
	tParameter      *parameter,
	tRateControl    *rateControl,
	BYTE            *bufY,          /* source picture buffer */
	BYTE            *bufU,
	BYTE            *bufV,
	BYTE            *bufYR,         /* reconstruction picture buffer */
	BYTE            *bufUR,
	BYTE            *bufVR,
	int             pictureType,
	int             pictureIndex,   /* P=0,B1=1,B2=2,... */
	short           forwardMV[][2], /* motion vector field */
	short           backwardMV[][2],
	int             mbType[],
	short           codedBPattern[],
	int             MQuant[]);

int InitParameter(tParameter *parameter);

int InitData(tData *aData, tParameter *aParameter);

void Init_DCT(void);


short   Read_SIF(
	int             pictureNumber,
	BYTE            *y_buffer,
	BYTE            *cb_buffer,
	BYTE            *cr_buffer,
        tParameter      *parameter);

short   Read_TGA(
	int             pictureNumber,
	BYTE            *y_buffer,
	BYTE            *cb_buffer,
	BYTE            *cr_buffer,
	tParameter      *parameter);

short   Read_PPM(
	int             pictureNumber,
	BYTE            *y_buffer,
	BYTE            *cb_buffer,
	BYTE            *cr_buffer,
	tParameter      *parameter);

short   Read_YUV(
	int             pictureNumber,
	BYTE            *y_buffer,
	BYTE            *cb_buffer,
	BYTE            *cr_buffer,
	tParameter      *parameter);

int     Write_SIF(
	int             pictureNum,
	BYTE            *y_recon,
	BYTE            *cb_recon,
	BYTE            *cr_recon,
	tParameter      *parameter);

int     Write_TGA(
	int             pictureNum,
	BYTE            *y_recon,
	BYTE            *cb_recon,
	BYTE            *cr_recon,
	tParameter      *parameter);

int     Write_PPM(
	int             pictureNum,
	BYTE            *y_recon,
	BYTE            *cb_recon,
	BYTE            *cr_recon,
	tParameter      *parameter);

void    yuvtorgb(
	int             y_recon,
	int             cb_recon,
	int             cr_recon,
	int             *pr,
	int             *pg,
	int             *pb);

int     Write_YUV(
	int             pictureNum,
	BYTE            *y_recon,
	BYTE            *cb_recon,
	BYTE            *cr_recon,
	tParameter      *parameter);

void    convert420to422(
	BYTE    *chromPicture,
	int             chromWidth,
	int             chromHeight);

void    filter2(
	int     n,
	int     *F,
	int     *G);

void convert420to444(
	BYTE    *chrom420,
	BYTE    *chrom444,
	int             chromWidth,
	int             chromHeight); 
