/* File: flc.h */

/* needs updating for picture dimension constants */

/*
 *      $Log:   flc.h,v $
 * Revision 1.3      93/08/20  21:15:53  hanamura
 * MPEG1 encoder minor revision
 * 
 * Revision 1.2  93/06/15  14:59:40  oosa
 * *** empty log message ***
 * 
 * Revision 1.1  1993/03/10  20:32:40  au
 * Initial revision
 *
 */

/*      sequence flc    */
#define bSequenceHeaderCode             32      /*      bslbf   */
#define bHorizontalSize                 12      /*      uimsbf  */
#define bVerticalSize                   12      /*      uimsbf  */
#define bPelAspectRatio                 4       /*      uimsbf  */
#define bPictureRate                    4       /*      uimsbf  */
#define bBitRate                        18      /*      uimsbf  */
#define bMarkerBit                      1       /*      "1      */
#define bVbvBufferSize                  10      /*      uimsbf  */
#define bConstrainedParameterFlag       1
#define bLoadIntraQuantizerMatrix       1
#define bIntraQuantizer                 8       /*      uimsbf  */
#define bLoadNonIntraQuantizerMatrix    1       
#define bNonIntraQuantizer              8       /*      uimsbf  */
#define bSequenceEndCode                32      /*      bslbf   */

#define cSequenceHeaderCode             0x000001B3      /*      bslbf   */
#define cHorizontalSize                 kLuminWidth     /*      uimsbf  */
#define cVerticalSize                   kLuminHeight    /*      uimsbf  */
#define cPelAspectRatio                 12              /*      uimsbf  */
#define cPictureRate                    4               /*      uimsbf  */
#define cBitRate                        400             /*      uimsbf  */
#define cMarkerBit                      1               /*      "1"     */
#define cVbvBufferSize                  1               /*      NEED    */
#define cConstrainedParameterFlag       1               /*      NEED    */
#define cLoadIntraQuantizerMatrix       0               /* default (0), else (1)  NEED */
#define cLoadNonIntraQuantizerMatrix    0               /* default (0), else (1)  NEED */
#define cSequenceEndCode                0x000001B7      /* bslbf   */

/*      group of picture flc    */

#define bGOPHeaderCode                  32      /*      bslbf   */
#define bTimeCode                       25      /*      NEED    */
#define bClosedGOP                      1       /*      NEED    */
#define bBrokenLink                     1       /*      NEED    */

#define cGOPHeaderCode                  0x000001B8   /*      bslbf   */
#define cTimeCode                       25      /*      NEED    */
#define cClosedGOP                      0       /*      NEED    */
#define cBrokenLink                     0       /*      NEED    */


/*      picture flc     */

#define bPictureStartCode               32      /*      bslbf   */
#define bTemporalReference              10      /*      uimsbf  */
#define bPictureCodingType              3       /*      uimsbf  */
#define bVbvDelay                       16      /*      uimsbf  */
#define bFullPelForwardVector           1
#define bForwardFCode                   3       /*      uimsbf  */
#define bFullPelBackwardVector          1
#define bBackwardFCode                  3       /*      uimsbf  */
#define bExtraBitPicture                1       /*      uimsbf  */

#define cPictureStartCode               0x00000100   /*      bslbf   */
#define cTemporalReference              1       /*      NEED    */
#define cVbvDelay                       1       /*      uimsbf  */
#define cFullPelForwardVector           0
#define cForwardFCode                   3       /*      uimsbf  */
#define cFullPelBackwardVector          0
#define cBackwardFCode                  3       /*      uimsbf  */
#define cExtraBitPicture                0       /*      uimsbf  */

/*      slice flc       */

#define bSliceStartCode                 32      /*      bslbf   */
#define bQuantizerScale                 5       /*      uimsbf  */
#define bExtraBitSlice                  1       /*      uimsbf  */

#define cSliceStartCode                 0x00000101  /*      bslbf   */
#define cQuantizerScale                 5       /*      NEED - uimsbf   */
#define cExtraBitSlice                  0       /*      uimsbf  */

/*      MB flc  */

#define bFrameMotionType                2       /*      uimsbf  */
#define bFieldMotionType                2       /*      uimsbf  */
#define bEndOfMacroBlock                1       /*      "1"    */
