/* File: GlobalVar.h */

/*
 *      $Log:   GlobalVar.h,v $
 * Revision 1.1.1.1  93/03/29  11:27:53  oosa
 * MPEG1 encoder/decoder initial revision
 * 
 * Revision 1.1  1993/03/10  20:32:40  au
 * Initial revision
 *
*/


/* _length represents the length of the variable length code (VLC)
   _value represents the right justified numerical value of the VLC.
   For example, 00011, would have a length of 5 and a value of 3.

*/

/* Macroblock address increment VLC table (B.1) */
BYTE    MBA_length[MBABitsLen] = {
	11, 1, 3, 3, 4, 4, 5, 5, 7, 7, 8, 8, 8, 8, 8, 8,
	   10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,
	   11,11,11};

BYTE    MBA_value[MBABitsLen] = {
	 8, 1, 3, 2, 3, 2, 3, 2, 7, 6,11,10, 9, 8, 7, 6,
	   23,22,21,20,19,18,35,34,33,32,31,30,29,28,27,
	   26,25,24};

/* Coded block pattern VLC table (B.3) */
BYTE    CBP_length[cpbBitsLen] = {0,
	5, 5, 6, 4, 7, 7, 8, 4, 7, 7,
	8, 5, 8, 8, 8, 4, 7, 7, 8, 5,
	8, 8, 8, 6, 8, 8, 9, 5, 8, 8,
	9, 4, 7, 7, 8, 6, 8, 8, 9, 5,
	8, 8, 8, 5, 8, 8, 9, 5, 8, 8,
	8, 5, 8, 8, 9, 5, 8, 8, 9, 3,
	5, 5, 6};

BYTE    CBP_value[cpbBitsLen] = {0,
	11,  9, 13, 13, 23, 19, 31, 12, 22, 18,
	30, 19, 27, 23, 19, 11, 21, 17, 29, 17,
	25, 21, 17, 15, 15, 13,  3, 15, 11,  7,
	 7, 10, 20, 16, 28, 14, 14, 12,  2, 16,
	24, 20, 16, 14, 10,  6,  6, 18, 26, 22,
	18, 13,  9,  5,  5, 12,  8,  4,  4,  7,
	10,  8, 12};

/* DC predition error size for luminance (B.5a) */
BYTE    DC_Y_length[DCPredSizeLen]   = {3, 2, 2, 3, 3, 4, 5,  6,  7};
BYTE    DC_Y_value[DCPredSizeLen]  = {4, 0, 1, 5, 6,14,30, 62,126};

/* DC prediction error size for chrominance (B.5b) */
BYTE    DC_C_length[DCPredSizeCLen]  = {2, 2, 2, 3, 4, 5, 6,  7,  8};
BYTE    DC_C_value[DCPredSizeCLen] = {0, 1, 2, 6,14,30,62,126,254};

/* dct_coef_next:  AC run-level events.  Entries are initialized in  
   a separate module */

BYTE    AC_length[64][256]; 
BYTE    AC_value[64][256];  

/* motion vector VLCs:  table B.4 */
BYTE    MV_length[VlcCodeMagnitudeLen] = {
	 1, 3, 4, 5, 7, 8, 8, 8, 10,10,10,11,11,11,11,11,11,
	 3, 4, 5, 7, 8, 8, 8, 10,10,10,11,11,11,11,11,11};

BYTE    MV_value[VlcCodeMagnitudeLen] = {
	 1, 2, 2, 2, 6,10, 8, 6, 22,20,18,34,32,30,28,26,24,
	 3, 3, 3, 7,11, 9, 7, 23,21,19,35,33,31,29,27,25};

/* Intra picture macroblock type tables (B.2a)  */
BYTE    MB_typeI_length[MBTypeILen] = {1, 2};
BYTE    MB_typeI_value[MBTypeILen] = {1, 1};


BYTE    MB_typeI_switch[MBTypeILen] = {kIntraType, kIntraType | kModifiedMQ};

/* Predictive picture macroblock type table (B.2b) */
BYTE    MB_typeP_length[MBTypePLen] = {1, 2, 3, 5, 5, 5, 6, 7};
BYTE    MB_typeP_value[MBTypePLen] = {1, 1, 1, 3, 2, 1, 1, 1};

short   MB_typeP_switch[MBTypePLen] = {
	kForwardMV | kMCType | kCodedType,
	kCodedType,
        kForwardMV | kMCType, 
        kIntraType, 
	kForwardMV | kMCType | kCodedType | kModifiedMQ,
	kCodedType | kModifiedMQ, 
        kIntraType | kModifiedMQ, 
        0};

/* Bi-directional picture macroblock type table (B.2c) */
BYTE    MB_typeB_length[MBTypeBLen] = {2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 6, 7};
BYTE    MB_typeB_value[MBTypeBLen] = {2, 3, 2, 3, 2, 3, 3, 2, 3, 2, 1, 1};

short   MB_typeB_switch[MBTypeBLen] = {
	kForwardMV | kBackwardMV | kMCType,
	kForwardMV | kBackwardMV | kMCType | kCodedType,
	kBackwardMV | kMCType,
	kBackwardMV | kMCType | kCodedType,
	kForwardMV | kMCType,
	kForwardMV | kMCType | kCodedType,
	kIntraType,
	kForwardMV | kBackwardMV | kMCType | kCodedType | kModifiedMQ,
	kForwardMV | kMCType | kCodedType | kModifiedMQ,
	kBackwardMV | kMCType | kCodedType | kModifiedMQ,
	kIntraType | kModifiedMQ,
	0};
