/* File: PerformDct */

/*
 *      $Log:   PerfDct.c,v $
 * Revision 1.1.1.1  93/03/29  11:27:59  oosa
 * MPEG1 encoder/decoder initial revision
 * 
 * Revision 1.1  1993/03/10  20:30:43  au
 * Initial revision
 *
 */

#include <stdio.h>
#include "consts.h"
#include "mpeg1.h"
#include "encoder.pro"

/* zz scan order offset */

static BYTE     zz[kDCTLen] =
{
     0,  1,  5,  6, 14, 15, 27, 28,
     2,  4,  7, 13, 16, 26, 29, 42,
     3,  8, 12, 17, 25, 30, 41, 43,
     9, 11, 18, 24, 31, 40, 44, 53,
    10, 19, 23, 32, 39, 45, 52, 54,
    20, 22, 33, 38, 46, 51, 55, 60,
    21, 34, 37, 47, 50, 56, 59, 61,
    35, 36, 48, 49, 57, 58, 62, 63
};


void    PerformDct(
	int             mbType,
	BYTE            currentMB[],
	int             *currentMBDiff,
	int             *currentMBDiffU,
	int             *currentMBDiffV,
	int             mbIndex)
{
	int             currentIndex, currentIndex1, currentIndex2, bufIndex,
			line, pix, row, col;
	
	float           dctBuf[kDCTLen], dctTrBuf[kDCTLen], dctTempBuf[kDCTLen];


	for (line = 0; line < kMBHeight; line += kDCTSize)
	{
		for (pix = 0; pix < kMBWidth; pix += kDCTSize)
		{
			currentIndex2 = line * kMBWidth + pix;

			for (row = 0, currentIndex = 0, currentIndex1 = currentIndex2;
					row < kDCTSize; row++, currentIndex1 += kMBWidthDCT)
			{
				for (col = 0; col < kDCTSize; col++,
						currentIndex++, currentIndex1++)
				{
					dctBuf[currentIndex] = currentMBDiff[currentIndex1];
				}
			}

			/*      perform DCT     */

			dct8x8(dctBuf, dctTrBuf);

			/*      perform zz scan */

			for (row = 0; row < kDCTLen; row++)
					dctTempBuf[zz[row]] = dctTrBuf[row];

			/*      return transformed data         */

			for (row = 0, currentIndex = 0, currentIndex1 = currentIndex2;
					row < kDCTSize; row++, currentIndex1 += kMBWidthDCT)
			{
				for (col = 0; col < kDCTSize; col++,
						currentIndex++, currentIndex1++)
				{
					currentMBDiff[currentIndex1] =
							(dctTempBuf[currentIndex] >= 0.0) ?
							(dctTempBuf[currentIndex] + 0.5) :
							(dctTempBuf[currentIndex] - 0.5);

				}
			}
		}
	}

	/*      chrom DCT       */

	/*      U       */

	for (row = 0; row < kDCTLen; row++)
	{
		dctBuf[row] = currentMBDiffU[row];
	}

	/*      perform DCT     */

	dct8x8(dctBuf, dctTrBuf);

	/*      perform zz scan */

	for (row = 0; row < kDCTLen; row++)
			dctTempBuf[zz[row]] = dctTrBuf[row];

	/*      return transformed data         */

	for (currentIndex = 0; currentIndex < kDCTLen; currentIndex++)
	{
		currentMBDiffU[currentIndex] = (dctTempBuf[currentIndex] >= 0.0) ?
				(dctTempBuf[currentIndex] + 0.5) :
				(dctTempBuf[currentIndex] - 0.5);
	}

	/*      V       */

	for (row = 0; row < kDCTLen; row++)
	{
		dctBuf[row] = currentMBDiffV[row];
	}

	/*      perform DCT     */

	dct8x8(dctBuf, dctTrBuf);

	/*      perform zz scan */

	for (row = 0; row < kDCTLen; row++)
		dctTempBuf[zz[row]] = dctTrBuf[row];

	/*      return transformed data         */

	for (currentIndex = 0; currentIndex < kDCTLen; currentIndex++)
	{
		currentMBDiffV[currentIndex] = (dctTempBuf[currentIndex] >= 0.0) ?
				(dctTempBuf[currentIndex] + 0.5) :
				(dctTempBuf[currentIndex] - 0.5);
	}
}
