/* File: writeBits.c */

/*
 *      $Log:   writeBits.c,v $
 * Revision 1.1.1.1  93/03/29  11:28:01  oosa
 * MPEG1 encoder/decoder initial revision
 * 
 * Revision 1.1  1993/03/10  20:30:43  au
 * Initial revision
 *
 */

#include <stdio.h>
#include "consts.h"
#include "mpeg1.h"
#include "encoder.pro"

#define kBufSize        1024
#define kIntNumBits     32

FILE    *gBitStream;

void    writeBits(
	unsigned int    bits,
	short           numBits,
	short           startCode)
{
	
	extern FILE             *gBitStream;

	static unsigned int     buf[kBufSize] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	static short            wdPtr = 0, wdIndex = 0;

	short                   srcStart, index;
	unsigned int            tempBits;
	int						i;
	unsigned int			temp;

	if (startCode == -1)    /*      flush buffer    */
	{
		for (i = 0; i < wdIndex + 1; i++)
		{
			temp = buf[i];
			putc(temp>>24,gBitStream);
			putc(temp>>16,gBitStream);
			putc(temp>>8,gBitStream);
			putc(temp,gBitStream);
		}
		/*fwrite(buf, sizeof (unsigned int), wdIndex + 1, gBitStream);*/
		fclose(gBitStream);
		return;
	}

	if (! numBits)
		return;

	srcStart = kIntNumBits - numBits;

	if (startCode == 1)             /*      check if byte align             */
	{
		while (wdPtr % 8)
		{
			/*      do byte alignment       */

			wdPtr++;

			if (wdPtr == kIntNumBits)
			{
				wdIndex++;
				wdPtr = 0;

				if (wdIndex == kBufSize)
				{
					for (i = 0; i < kBufSize; i++)
					{
						temp = buf[i];
						putc(temp>>24,gBitStream);
						putc(temp>>16,gBitStream);
						putc(temp>>8,gBitStream);
						putc(temp,gBitStream);
					}
					/*fwrite(buf, sizeof (unsigned int), kBufSize, gBitStream);*/
					wdIndex = 0;

					for (index = 0; index < kBufSize; index++)
						buf[index] = 0;         /*      clear buffer    */
				}
			}
		}
	}

	if (srcStart > wdPtr)
	{
		tempBits = bits << (srcStart - wdPtr);

		buf[wdIndex] |= tempBits;
		wdPtr += numBits;
	}
	else if (srcStart == wdPtr)
	{
		buf[wdIndex] |= bits;
		wdPtr = 0;
		wdIndex++;

		if (wdIndex == kBufSize)
		{
			for (i = 0; i < kBufSize; i++)
			{
				temp = buf[i];
				putc(temp>>24,gBitStream);
				putc(temp>>16,gBitStream);
				putc(temp>>8,gBitStream);
				putc(temp,gBitStream);
			}
			/*fwrite(buf, sizeof (unsigned int), kBufSize, gBitStream);*/
			wdIndex = 0;

			for (index = 0; index < kBufSize; index++)
				buf[index] = 0;         /*      clear buffer    */
		}
	}
	else    /*      does not fit in one location    */
	{
		tempBits = bits >> (wdPtr - srcStart);
		buf[wdIndex] |= tempBits;
		numBits = wdPtr - srcStart;             /*      new numBits     */
		wdPtr = 0;
		wdIndex++;

		if (wdIndex == kBufSize)
		{
			for (i = 0; i < kBufSize; i++)
			{
				temp = buf[i];
				putc(temp>>24,gBitStream);
				putc(temp>>16,gBitStream);
				putc(temp>>8,gBitStream);
				putc(temp,gBitStream);
			}
			/*fwrite(buf, sizeof (unsigned int), kBufSize, gBitStream);*/
			wdIndex = 0;

			for (index = 0; index < kBufSize; index++)
				buf[index] = 0;         /*      clear buffer    */
		}

		tempBits = bits << (kIntNumBits - numBits);
		buf[wdIndex] |= tempBits;
		wdPtr += numBits;
	}
}
